
/*  A Bison parser, made from ./parser.y
    by GNU Bison version 1.28  */

#define YYBISON 1  /* Identify Bison output.  */

#define	IDENTIFIER	257
#define	SYMBOL	258
#define	TYPE_FLOAT	259
#define	TYPE_POINT	260
#define	TYPE_STRING	261
#define	TYPE_COLOR	262
#define	TYPE_NORMAL	263
#define	TYPE_VECTOR	264
#define	TYPE_VOID	265
#define	TYPE_MATRIX	266
#define	TYPE_UNIFORM	267
#define	TYPE_VARYING	268
#define	SHADER_TYPE_SURFACE	269
#define	SHADER_TYPE_VOLUME	270
#define	SHADER_TYPE_IMAGER	271
#define	SHADER_TYPE_TRANSFORMATION	272
#define	SHADER_TYPE_DISPLACEMENT	273
#define	SHADER_TYPE_LIGHT	274
#define	SHADER_TYPE_ATMOSPHERE	275
#define	ATTRIBUTE	276
#define	OPTION	277
#define	RENDERERINFO	278
#define	INCIDENT	279
#define	OPPOSITE	280
#define	LIGHTSOURCE	281
#define	EXTERN	282
#define	TEXTUREINFO	283
#define	IF	284
#define	ELSE	285
#define	WHILE	286
#define	FOR	287
#define	CONTINUE	288
#define	BREAK	289
#define	RETURN	290
#define	ILLUMINATE	291
#define	ILLUMINANCE	292
#define	SOLAR	293
#define	TEXTUREMAP	294
#define	ENVIRONMENT	295
#define	BUMP	296
#define	SHADOW	297
#define	SETXCOMP	298
#define	SETYCOMP	299
#define	SETZCOMP	300
#define	SETCOMP	301
#define	ADD_ASSIGN	302
#define	SUB_ASSIGN	303
#define	MUL_ASSIGN	304
#define	DIV_ASSIGN	305
#define	OR_OP	306
#define	AND_OP	307
#define	GE_OP	308
#define	LE_OP	309
#define	EQ_OP	310
#define	NE_OP	311
#define	NEG	312
#define	FLOAT_CONSTANT	313
#define	STRING_LITERAL	314

#line 5 "./parser.y"

#ifdef	WIN32
#include <malloc.h>
#pragma warning(disable : 4786)
#endif

#include <algorithm>
#include <iostream>
#include <map>
#include <string>
#include <vector>
#include <cassert>

#include	"parsenode.h"

using namespace Aqsis;

namespace Aqsis
{

extern CqString ParseStreamName;
extern std::ostream* ParseErrorStream;
extern TqInt ParseLineNumber;
extern TqBool ParseSucceeded;
CqParseNode*	ParseTreePointer;
std::vector<CqString>	ParseNameSpaceStack;

TqBool	FindVariable(const char* name, SqVarRef& ref);
TqBool	FindFunction(const char* name, std::vector<SqFuncRef>& Ref);
CqString strNameSpace();
void	TypeCheck();
void	Optimise();
void	InitStandardNamespace();

}


#line 44 "./parser.y"
typedef union{
	CqParseNode*	m_pParseNode;
	TqInt			m_VarType;
	CqString*		m_ShaderType;
	TqFloat			m_FloatConst;
	CqString*	m_Identifier;
	struct{
		SqVarRef		VarRef;
		SqFuncRef		FuncRef;
		TqInt				eType;
	}				m_pSymbol;
	struct{
		TqInt				Type;
		CqString*	Space;
	}				m_TypeAndSpace;
	EqCommType		m_CommType;
} YYSTYPE;
#line 62 "./parser.y"

extern TqInt yylex();
static void yyerror(const CqString Message);
#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		344
#define	YYFLAG		-32768
#define	YYNTBASE	81

#define YYTRANSLATE(x) ((unsigned)(x) <= 314 ? yytranslate[x] : 124)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    70,     2,     2,     2,     2,     2,     2,    71,
    72,    67,    63,    78,    64,    68,    66,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,    54,    77,    59,
    48,    57,    53,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
    79,     2,    80,    65,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    75,     2,    76,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
    27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
    37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
    47,    49,    50,    51,    52,    55,    56,    58,    60,    61,
    62,    69,    73,    74
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     2,     5,     7,     9,    18,    26,    33,    39,    43,
    46,    50,    53,    55,    57,    59,    61,    63,    65,    67,
    71,    74,    77,    81,    84,    86,    88,    92,    95,    97,
   102,   108,   111,   113,   118,   124,   127,   132,   134,   138,
   140,   142,   144,   146,   148,   150,   152,   154,   156,   158,
   161,   163,   166,   168,   171,   173,   176,   178,   181,   183,
   185,   187,   190,   193,   196,   199,   203,   206,   208,   211,
   213,   217,   220,   222,   226,   232,   236,   246,   251,   259,
   265,   275,   281,   289,   299,   311,   314,   316,   318,   320,
   322,   326,   330,   334,   338,   342,   346,   349,   351,   357,
   360,   362,   364,   366,   371,   373,   375,   377,   379,   383,
   391,   425,   427,   429,   431,   433,   435,   437,   441,   445,
   449,   453,   456,   460,   464,   468,   472,   476,   483,   490,
   497,   504,   511,   516,   520,   522,   526,   533,   539,   545,
   550,   552,   554,   556,   558,   560,   562,   566,   569,   573,
   575,   577,   579,   581,   583,   585,   587,   589,   591,   593,
   595,   602
};

static const short yyrhs[] = {    82,
     0,    81,    82,     0,    83,     0,    84,     0,    86,     3,
    71,    87,    72,    75,   103,    76,     0,    86,     3,    71,
    72,    75,   103,    76,     0,    85,    87,    72,    75,   103,
    76,     0,    85,    72,    75,   103,    76,     0,    89,     3,
    71,     0,     3,    71,     0,    89,     4,    71,     0,     4,
    71,     0,    20,     0,    15,     0,    16,     0,    19,     0,
    18,     0,    17,     0,    88,     0,    87,    77,    88,     0,
    87,    77,     0,    89,    90,     0,    28,    89,    90,     0,
    95,    96,     0,    96,     0,    91,     0,    90,    78,    91,
     0,     3,    92,     0,     3,     0,     3,    79,   121,    80,
     0,     3,    79,   121,    80,    93,     0,     4,    92,     0,
     4,     0,     4,    79,   121,    80,     0,     4,    79,   121,
    80,    93,     0,    48,   108,     0,    48,    75,    94,    76,
     0,   108,     0,    94,    78,   108,     0,    14,     0,    13,
     0,     5,     0,     7,     0,    11,     0,    97,     0,    98,
     0,    99,     0,   100,     0,   101,     0,     6,   102,     0,
     6,     0,     8,   102,     0,     8,     0,    10,   102,     0,
    10,     0,     9,   102,     0,     9,     0,    12,   102,     0,
    12,     0,    74,     0,   104,     0,   103,   104,     0,   113,
    77,     0,   114,    77,     0,   123,    77,     0,    36,   108,
    77,     0,   106,    77,     0,   105,     0,    88,    77,     0,
    84,     0,    75,   103,    76,     0,    75,    76,     0,    77,
     0,    30,   112,   104,     0,    30,   112,   104,    31,   104,
     0,    32,   112,   104,     0,    33,    71,   108,    77,   112,
    77,   108,    72,   104,     0,    39,    71,    72,   104,     0,
    39,    71,   108,    78,   108,    72,   104,     0,    37,    71,
   108,    72,   104,     0,    37,    71,   108,    78,   108,    78,
   108,    72,   104,     0,    38,    71,   108,    72,   104,     0,
    38,    71,   108,    78,   108,    72,   104,     0,    38,    71,
   108,    78,   108,    78,   108,    72,   104,     0,    38,    71,
   108,    78,   108,    78,   108,    78,   108,    72,   104,     0,
   107,   121,     0,   107,     0,    35,     0,    34,     0,   110,
     0,   108,    68,   108,     0,   108,    66,   108,     0,   108,
    67,   108,     0,   108,    65,   108,     0,   108,    63,   108,
     0,   108,    64,   108,     0,    64,   108,     0,   109,     0,
   112,    53,   108,    54,   108,     0,    96,   108,     0,   121,
     0,   116,     0,     4,     0,     4,    79,   108,    80,     0,
    74,     0,   114,     0,   123,     0,   113,     0,    71,   108,
    72,     0,    71,   108,    78,   108,    78,   108,    72,     0,
    71,   108,    78,   108,    78,   108,    78,   108,    78,   108,
    78,   108,    78,   108,    78,   108,    78,   108,    78,   108,
    78,   108,    78,   108,    78,   108,    78,   108,    78,   108,
    78,   108,    72,     0,    57,     0,    58,     0,    59,     0,
    60,     0,    61,     0,    62,     0,    71,   112,    72,     0,
   108,   111,   108,     0,   112,    56,   112,     0,   112,    55,
   112,     0,    70,   112,     0,     4,    48,   108,     0,     4,
    49,   108,     0,     4,    50,   108,     0,     4,    51,   108,
     0,     4,    52,   108,     0,     4,    79,   108,    80,    48,
   108,     0,     4,    79,   108,    80,    49,   108,     0,     4,
    79,   108,    80,    50,   108,     0,     4,    79,   108,    80,
    51,   108,     0,     4,    79,   108,    80,    52,   108,     0,
     4,    71,   115,    72,     0,     4,    71,    72,     0,   108,
     0,   115,    78,   108,     0,   117,    71,   118,   119,   120,
    72,     0,   117,    71,   118,   120,    72,     0,   117,    71,
   118,   119,    72,     0,   117,    71,   118,    72,     0,    40,
     0,    41,     0,    42,     0,    43,     0,     4,     0,    74,
     0,    79,   108,    80,     0,    78,   108,     0,   120,    78,
   108,     0,    73,     0,    21,     0,    19,     0,    27,     0,
    15,     0,    22,     0,    23,     0,    24,     0,    25,     0,
    26,     0,    29,     0,   122,    71,   108,    78,     4,    72,
     0,   122,    71,   108,    78,   108,    78,     4,    72,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   148,   149,   154,   155,   159,   203,   213,   245,   261,   267,
   273,   284,   298,   299,   300,   301,   302,   303,   307,   320,
   331,   335,   406,   452,   456,   460,   466,   474,   483,   490,
   497,   506,   520,   530,   540,   555,   561,   576,   582,   590,
   591,   595,   599,   603,   607,   608,   609,   610,   611,   615,
   619,   626,   630,   637,   641,   648,   652,   659,   663,   670,
   674,   680,   688,   689,   697,   702,   708,   709,   710,   736,
   737,   738,   739,   740,   748,   762,   769,   784,   790,   804,
   813,   829,   842,   856,   873,   894,   895,   899,   903,   911,
   912,   923,   934,   945,   956,   967,   978,   988,   989,  1010,
  1052,  1056,  1057,  1061,  1066,  1070,  1071,  1072,  1073,  1076,
  1084,  1108,  1109,  1110,  1111,  1112,  1113,  1117,  1120,  1127,
  1134,  1141,  1149,  1155,  1169,  1183,  1197,  1211,  1218,  1236,
  1254,  1272,  1293,  1303,  1314,  1320,  1328,  1342,  1356,  1362,
  1371,  1377,  1383,  1389,  1398,  1402,  1409,  1413,  1419,  1428,
  1433,  1434,  1435,  1436,  1437,  1438,  1439,  1440,  1441,  1442,
  1447,  1468
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","IDENTIFIER",
"SYMBOL","TYPE_FLOAT","TYPE_POINT","TYPE_STRING","TYPE_COLOR","TYPE_NORMAL",
"TYPE_VECTOR","TYPE_VOID","TYPE_MATRIX","TYPE_UNIFORM","TYPE_VARYING","SHADER_TYPE_SURFACE",
"SHADER_TYPE_VOLUME","SHADER_TYPE_IMAGER","SHADER_TYPE_TRANSFORMATION","SHADER_TYPE_DISPLACEMENT",
"SHADER_TYPE_LIGHT","SHADER_TYPE_ATMOSPHERE","ATTRIBUTE","OPTION","RENDERERINFO",
"INCIDENT","OPPOSITE","LIGHTSOURCE","EXTERN","TEXTUREINFO","IF","ELSE","WHILE",
"FOR","CONTINUE","BREAK","RETURN","ILLUMINATE","ILLUMINANCE","SOLAR","TEXTUREMAP",
"ENVIRONMENT","BUMP","SHADOW","SETXCOMP","SETYCOMP","SETZCOMP","SETCOMP","'='",
"ADD_ASSIGN","SUB_ASSIGN","MUL_ASSIGN","DIV_ASSIGN","'?'","':'","OR_OP","AND_OP",
"'>'","GE_OP","'<'","LE_OP","EQ_OP","NE_OP","'+'","'-'","'^'","'/'","'*'","'.'",
"NEG","'!'","'('","')'","FLOAT_CONSTANT","STRING_LITERAL","'{'","'}'","';'",
"','","'['","']'","file","definitions","shader_definition","function_definition",
"function_declaration","shader_type","formals","variable_definitions","typespec",
"def_expressions","def_expression","def_init","def_array_initialisers","array_initialisers",
"detail","type","pspace","cspace","vspace","nspace","mspace","spacetype","statements",
"statement","loop_control","loop_modstmt","loop_mod","expression","cast_expr",
"primary","relational_operator","relation","assignexpression","procedurecall",
"proc_arguments","texture","texture_type","texture_filename","channel","texture_arguments",
"number","comm_type","comm_function", NULL
};
#endif

static const short yyr1[] = {     0,
    81,    81,    82,    82,    83,    83,    84,    84,    85,    85,
    85,    85,    86,    86,    86,    86,    86,    86,    87,    87,
    87,    88,    88,    89,    89,    90,    90,    91,    91,    91,
    91,    91,    91,    91,    91,    92,    93,    94,    94,    95,
    95,    96,    96,    96,    96,    96,    96,    96,    96,    97,
    97,    98,    98,    99,    99,   100,   100,   101,   101,   102,
   103,   103,   104,   104,   104,   104,   104,   104,   104,   104,
   104,   104,   104,   104,   104,   105,   105,   105,   105,   105,
   105,   105,   105,   105,   105,   106,   106,   107,   107,   108,
   108,   108,   108,   108,   108,   108,   108,   108,   108,   109,
   110,   110,   110,   110,   110,   110,   110,   110,   110,   110,
   110,   111,   111,   111,   111,   111,   111,   112,   112,   112,
   112,   112,   113,   113,   113,   113,   113,   113,   113,   113,
   113,   113,   114,   114,   115,   115,   116,   116,   116,   116,
   117,   117,   117,   117,   118,   118,   119,   120,   120,   121,
   122,   122,   122,   122,   122,   122,   122,   122,   122,   122,
   123,   123
};

static const short yyr2[] = {     0,
     1,     2,     1,     1,     8,     7,     6,     5,     3,     2,
     3,     2,     1,     1,     1,     1,     1,     1,     1,     3,
     2,     2,     3,     2,     1,     1,     3,     2,     1,     4,
     5,     2,     1,     4,     5,     2,     4,     1,     3,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
     1,     2,     1,     2,     1,     2,     1,     2,     1,     1,
     1,     2,     2,     2,     2,     3,     2,     1,     2,     1,
     3,     2,     1,     3,     5,     3,     9,     4,     7,     5,
     9,     5,     7,     9,    11,     2,     1,     1,     1,     1,
     3,     3,     3,     3,     3,     3,     2,     1,     5,     2,
     1,     1,     1,     4,     1,     1,     1,     1,     3,     7,
    33,     1,     1,     1,     1,     1,     1,     3,     3,     3,
     3,     2,     3,     3,     3,     3,     3,     6,     6,     6,
     6,     6,     4,     3,     1,     3,     6,     5,     5,     4,
     1,     1,     1,     1,     1,     1,     3,     2,     3,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     6,     8
};

static const short yydefact[] = {     0,
     0,     0,    42,    51,    43,    53,    57,    55,    44,    59,
    41,    40,    14,    15,    18,    17,    16,    13,     0,     1,
     3,     4,     0,     0,     0,     0,    25,    45,    46,    47,
    48,    49,    10,    12,    60,    50,    52,    56,    54,    58,
     2,     0,     0,     0,    19,     0,     0,     0,     0,    24,
     0,     0,     0,    21,    29,    33,    22,    26,     0,     9,
    11,    23,     0,   154,   152,   151,   155,   156,   157,   158,
   159,   153,   160,     0,     0,     0,    89,    88,     0,     0,
     0,     0,     0,    73,    70,     0,     0,     0,    61,    68,
     0,    87,     0,     0,     0,     0,     0,    20,     0,     0,
    28,     0,    32,     0,     0,     0,     0,     0,     0,     0,
     0,    12,     0,   103,   141,   142,   143,   144,     0,     0,
     0,   150,   105,     0,     0,    98,    90,     0,   108,   106,
   102,     0,   101,   107,     0,     0,     0,     0,     0,     0,
     0,    72,     0,    69,    29,    33,     8,    62,    67,    86,
    63,    64,     0,    65,     0,    36,     0,     0,    27,     0,
     0,   123,   124,   125,   126,   127,   134,   135,     0,     0,
     0,     0,    97,   122,     0,     0,   100,   112,   113,   114,
   115,   116,   117,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,    74,     0,    76,     0,    66,     0,     0,
     0,     0,    71,     0,     7,    30,    34,     0,     0,   133,
     0,     0,     0,   109,     0,   118,    95,    96,    94,    92,
    93,    91,   119,     0,   121,   120,     0,   145,   146,     0,
     0,     0,     0,     0,     0,    78,     0,     0,     0,    31,
    35,     6,     0,   136,     0,     0,     0,     0,     0,   104,
     0,     0,    75,   140,     0,     0,     0,     0,     0,    80,
     0,    82,     0,     0,   103,     0,     0,     5,   128,   129,
   130,   131,   132,     0,    99,   148,     0,   139,     0,   138,
     0,     0,     0,     0,     0,     0,   161,     0,     0,    38,
     0,   147,   137,   149,     0,     0,    83,     0,    79,     0,
    37,     0,   110,     0,     0,     0,     0,     0,   162,    39,
     0,    77,    81,    84,     0,     0,     0,     0,    85,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,   111,     0,     0
};

static const short yydefgoto[] = {    19,
    20,    21,    85,    23,    24,    44,    86,    87,    57,    58,
   101,   240,   289,    26,   124,    28,    29,    30,    31,    32,
    36,    88,    89,    90,    91,    92,   125,   126,   127,   190,
   138,   129,   130,   169,   131,   132,   230,   257,   258,   133,
    95,   134
};

static const short yypact[] = {  1692,
   -54,   -47,-32768,   -30,-32768,   -30,   -30,   -30,-32768,   -30,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,  1632,-32768,
-32768,-32768,    57,    54,    32,   253,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,   404,   -19,    14,-32768,   120,   -11,     2,    11,-32768,
   120,  1045,    30,   375,   -39,   -28,    24,-32768,   105,-32768,
-32768,    24,   -21,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,  1225,  1225,    55,-32768,-32768,  1225,    69,
    81,    85,   691,-32768,-32768,    74,   134,   750,-32768,-32768,
    91,   101,   103,   107,   111,   108,  1045,-32768,  1225,   101,
-32768,   101,-32768,   120,   118,    77,  1225,  1225,  1225,  1225,
  1225,  1225,  1225,    96,-32768,-32768,-32768,-32768,  1225,  1225,
  1225,-32768,-32768,  1225,   617,-32768,-32768,   634,-32768,-32768,
-32768,   115,-32768,-32768,   634,  1225,  1596,   109,  1225,  1225,
  1083,-32768,   809,-32768,   -32,   -26,-32768,-32768,-32768,-32768,
-32768,-32768,  1225,-32768,   868,   617,    98,   116,-32768,  1045,
   119,   617,   617,   617,   617,   617,-32768,   617,   -57,   156,
  1154,  1225,-32768,-32768,   549,    34,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,  1225,  1225,  1225,  1225,  1225,  1225,  1225,
  1225,  1225,  1225,   164,     1,-32768,  1617,-32768,   674,   733,
  1045,   969,-32768,  1070,-32768,   150,   150,   927,  1045,-32768,
  1225,   189,   231,-32768,  1225,-32768,   123,   123,    27,   132,
   132,-32768,   617,  1736,   147,-32768,  1045,-32768,-32768,    29,
  1225,  1045,  1225,  1045,  1225,-32768,  1225,  1296,   130,-32768,
-32768,-32768,   986,   617,  1225,  1225,  1225,  1225,  1225,   189,
  1141,  1225,-32768,-32768,  1225,  1225,   -17,    53,    23,-32768,
  1212,-32768,   792,  1656,   -38,  1283,  1225,-32768,   617,   617,
   617,   617,   617,  1225,   617,   617,   418,-32768,    64,-32768,
  1225,  1225,  1225,  1045,  1225,  1045,-32768,   202,    -4,   617,
   851,-32768,-32768,   617,  1672,  1688,-32768,   910,-32768,   135,
-32768,  1225,-32768,  1225,  1045,  1045,  1045,  1225,-32768,   617,
  1314,-32768,-32768,-32768,  1704,  1225,  1045,  1336,-32768,  1225,
  1358,  1225,  1380,  1225,  1402,  1225,  1424,  1225,  1446,  1225,
  1468,  1225,  1490,  1225,  1512,  1225,  1534,  1225,  1556,  1225,
  1720,-32768,   210,-32768
};

static const short yypgoto[] = {-32768,
   193,-32768,     6,-32768,-32768,   166,   -16,    80,   175,   124,
   -48,    22,-32768,-32768,     0,-32768,-32768,-32768,-32768,-32768,
   163,   -79,   319,-32768,-32768,-32768,   255,-32768,-32768,-32768,
   -72,   -51,    44,-32768,-32768,-32768,-32768,-32768,   -27,    61,
-32768,   114
};


#define	YYLAST		1804


static const short yytable[] = {    27,
    93,   128,   135,   143,   228,    22,    45,   103,    99,   107,
   108,   109,   110,   111,   210,    99,    33,   155,    27,    99,
   211,    99,    27,    34,    22,    50,   107,   108,   109,   110,
   111,    93,   171,   287,    48,    49,    93,    98,    60,   100,
   172,    27,    45,    35,    61,    93,   100,   174,   176,   112,
   102,    27,   102,    27,   278,    52,    47,   113,    27,    59,
   255,     3,     4,     5,     6,     7,     8,     9,    10,    11,
    12,   301,    60,   302,   229,   191,    93,   192,   193,    25,
   208,    61,    27,    93,    42,    53,   191,    27,   192,   193,
    54,    93,   187,   188,   189,    94,    27,   103,    25,   282,
   254,   104,    46,    93,    97,   216,   255,   256,    93,     3,
     4,     5,     6,     7,     8,     9,    10,    11,    12,   225,
   226,    51,    55,    56,   280,   136,    94,    27,    43,   243,
   281,    94,    42,    46,    27,   293,   145,   146,    46,   139,
    94,   281,    27,   107,   108,   109,   110,   111,   161,    93,
   144,   140,   150,    54,    27,   141,    93,    93,   259,    27,
   157,   191,   158,   192,   193,    96,   171,   149,    37,    38,
    39,    94,    40,   122,   172,    93,   105,   206,    94,   151,
    93,   153,    93,   152,   154,   195,    94,   186,   187,   188,
   189,    93,   160,   209,   227,   207,    96,   239,    94,   189,
    27,    96,   193,    94,   267,   300,   309,    27,    27,   344,
    96,    41,   178,   179,   180,   181,   182,   183,   184,   185,
   186,   187,   188,   189,   106,    62,    27,   159,   241,   279,
     0,    27,    93,    27,    93,   212,   245,   246,   247,   248,
   249,    96,    27,     0,    94,     0,     0,     0,    96,     0,
     0,    94,    94,    93,    93,    93,    96,     3,     4,     5,
     6,     7,     8,     9,    10,    93,     0,     0,    96,     0,
    94,     0,     0,    96,     0,    94,     0,    94,     0,     0,
     0,     0,     0,    27,     0,    27,    94,   178,   179,   180,
   181,   182,   183,   184,   185,   186,   187,   188,   189,     0,
     0,     0,     0,     0,    27,    27,    27,     0,     0,     0,
   250,     0,     0,     0,    96,     0,    27,     0,     0,     0,
     0,    96,    96,     0,     0,     0,     0,    94,     0,    94,
     0,     0,     0,   137,     0,     0,     0,     0,     0,     0,
    96,     0,     0,     0,     0,    96,     0,    96,    94,    94,
    94,     0,     0,   156,     0,     0,    96,     0,     0,     0,
    94,   162,   163,   164,   165,   166,   168,   170,     0,     0,
     0,     0,     0,   173,     0,   175,     0,     0,   177,     3,
     4,     5,     6,     7,     8,     9,    10,    11,    12,     0,
   197,     0,     0,   199,   200,   202,     0,    96,     0,    96,
     0,     0,    42,     0,     0,     0,   148,   204,     3,     4,
     5,     6,     7,     8,     9,    10,    11,    12,    96,    96,
    96,     0,     0,     0,     0,   168,   213,     0,     0,     0,
    96,     0,     0,     0,     0,     0,     0,     0,   217,   218,
   219,   220,   221,   222,   223,   224,   194,     0,     0,     0,
     0,     0,     0,   196,     0,     0,     0,     0,     0,     0,
     0,   148,     0,     0,     0,   244,     0,     0,     0,   251,
     0,     0,     0,   148,   178,   179,   180,   181,   182,   183,
   184,   185,   186,   187,   188,   189,     0,   261,     0,   263,
     0,   264,   266,     0,     0,     0,     0,   292,     0,   269,
   270,   271,   272,   273,     0,     0,   275,     0,     0,   276,
   277,     0,     0,     0,     0,     0,     0,     0,     0,   236,
     0,   290,     0,     0,     0,     0,   148,     0,   291,     0,
     0,     0,     0,     0,     0,   294,   295,   296,     0,   298,
     0,     0,     0,     0,     0,   253,     0,     0,     0,     0,
   260,     0,   262,     0,     0,     0,   310,     0,   311,     0,
     0,   148,   315,     0,     0,     0,     0,     0,     0,     0,
   318,     0,     0,     0,   321,     0,   323,     0,   325,     0,
   327,     0,   329,     0,   331,     0,   333,     0,   335,     0,
   337,     0,   339,     0,   341,     0,     0,     0,     0,     0,
     0,     0,   297,     0,   299,   178,   179,   180,   181,   182,
   183,   184,   185,   186,   187,   188,   189,     0,     0,     0,
   214,     0,     0,   312,   313,   314,   215,     0,     0,     0,
     0,     0,     0,     0,     0,   319,     1,    63,     3,     4,
     5,     6,     7,     8,     9,    10,    11,    12,    64,     0,
     0,     0,    65,     0,    66,    67,    68,    69,    70,    71,
    72,    42,    73,    74,     0,    75,    76,    77,    78,    79,
    80,    81,    82,   178,   179,   180,   181,   182,   183,   184,
   185,   186,   187,   188,   189,     0,   191,     0,   192,   193,
     0,     0,     0,     1,    63,     3,     4,     5,     6,     7,
     8,     9,    10,    11,    12,    64,     0,     0,    83,    65,
    84,    66,    67,    68,    69,    70,    71,    72,    42,    73,
    74,     0,    75,    76,    77,    78,    79,    80,    81,    82,
   178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
   188,   189,     0,     0,     0,   232,     0,     0,     0,     0,
     0,   233,     1,    63,     3,     4,     5,     6,     7,     8,
     9,    10,    11,    12,    64,    83,   142,    84,    65,     0,
    66,    67,    68,    69,    70,    71,    72,    42,    73,    74,
     0,    75,    76,    77,    78,    79,    80,    81,    82,   178,
   179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
   189,     0,     0,     0,   234,     0,     0,     0,     0,     0,
   235,     1,    63,     3,     4,     5,     6,     7,     8,     9,
    10,    11,    12,    64,    83,   147,    84,    65,     0,    66,
    67,    68,    69,    70,    71,    72,    42,    73,    74,     0,
    75,    76,    77,    78,    79,    80,    81,    82,   178,   179,
   180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     0,     0,     0,   284,     0,     0,     0,     0,     0,   285,
     1,    63,     3,     4,     5,     6,     7,     8,     9,    10,
    11,    12,    64,    83,   203,    84,    65,     0,    66,    67,
    68,    69,    70,    71,    72,    42,    73,    74,     0,    75,
    76,    77,    78,    79,    80,    81,    82,   178,   179,   180,
   181,   182,   183,   184,   185,   186,   187,   188,   189,     0,
     0,     0,   303,     0,     0,     0,     0,     0,   304,     1,
    63,     3,     4,     5,     6,     7,     8,     9,    10,    11,
    12,    64,    83,   205,    84,    65,     0,    66,    67,    68,
    69,    70,    71,    72,    42,    73,    74,     0,    75,    76,
    77,    78,    79,    80,    81,    82,   178,   179,   180,   181,
   182,   183,   184,   185,   186,   187,   188,   189,     0,     0,
     0,   307,     0,     0,     0,     0,     0,   308,     1,    63,
     3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
    64,    83,   242,    84,    65,     0,    66,    67,    68,    69,
    70,    71,    72,    42,    73,    74,     0,    75,    76,    77,
    78,    79,    80,    81,    82,   178,   179,   180,   181,   182,
   183,   184,   185,   186,   187,   188,   189,     0,     0,     0,
     0,     0,     0,     0,     0,     0,   237,     1,    63,     3,
     4,     5,     6,     7,     8,     9,    10,    11,    12,    64,
    83,   268,    84,    65,     0,    66,    67,    68,    69,    70,
    71,    72,    42,    73,    74,     0,    75,    76,    77,    78,
    79,    80,    81,    82,     0,     0,   114,     3,     4,     5,
     6,     7,     8,     9,    10,     0,     0,    64,     0,     0,
     0,    65,     0,    66,    67,    68,    69,    70,    71,    72,
     0,    73,     0,     0,     0,     0,     0,     0,     0,    83,
     0,    84,   115,   116,   117,   118,   178,   179,   180,   181,
   182,   183,   184,   185,   186,   187,   188,   189,     0,     0,
     0,     0,     0,     0,     0,     0,   119,   238,     0,     0,
     0,     0,   120,   121,   201,   122,   123,   114,     3,     4,
     5,     6,     7,     8,     9,    10,     0,     0,    64,     0,
     0,     0,    65,     0,    66,    67,    68,    69,    70,    71,
    72,     0,    73,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,   115,   116,   117,   118,   178,   179,   180,
   181,   182,   183,   184,   185,   186,   187,   188,   189,     0,
     0,     0,     0,     0,     0,     0,     0,   119,   274,     0,
     0,     0,     0,   120,   121,   167,   122,   123,   114,     3,
     4,     5,     6,     7,     8,     9,    10,     0,     0,    64,
     0,     0,     0,    65,     0,    66,    67,    68,    69,    70,
    71,    72,     0,    73,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,   115,   116,   117,   118,   178,   179,
   180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     0,     0,     0,     0,     0,     0,     0,     0,   119,   283,
     0,     0,     0,     0,   120,   121,     0,   122,   123,   265,
     3,     4,     5,     6,     7,     8,     9,    10,     0,     0,
    64,     0,     0,     0,    65,     0,    66,    67,    68,    69,
    70,    71,    72,     0,    73,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,   115,   116,   117,   118,   178,
   179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
   189,     0,     0,     0,     0,     0,     0,     0,     0,   119,
   288,     0,     0,     0,     0,   120,   121,     0,   122,   123,
   178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
   188,   189,     0,     0,     0,     0,     0,     0,     0,     0,
     0,   316,   178,   179,   180,   181,   182,   183,   184,   185,
   186,   187,   188,   189,     0,     0,     0,     0,     0,     0,
     0,     0,     0,   320,   178,   179,   180,   181,   182,   183,
   184,   185,   186,   187,   188,   189,     0,     0,     0,     0,
     0,     0,     0,     0,     0,   322,   178,   179,   180,   181,
   182,   183,   184,   185,   186,   187,   188,   189,     0,     0,
     0,     0,     0,     0,     0,     0,     0,   324,   178,   179,
   180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     0,     0,     0,     0,     0,     0,     0,     0,     0,   326,
   178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
   188,   189,     0,     0,     0,     0,     0,     0,     0,     0,
     0,   328,   178,   179,   180,   181,   182,   183,   184,   185,
   186,   187,   188,   189,     0,     0,     0,     0,     0,     0,
     0,     0,     0,   330,   178,   179,   180,   181,   182,   183,
   184,   185,   186,   187,   188,   189,     0,     0,     0,     0,
     0,     0,     0,     0,     0,   332,   178,   179,   180,   181,
   182,   183,   184,   185,   186,   187,   188,   189,     0,     0,
     0,     0,     0,     0,     0,     0,     0,   334,   178,   179,
   180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     0,     0,     0,     0,     0,     0,     0,     0,     0,   336,
   178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
   188,   189,     0,     0,     0,     0,     0,     0,     0,     0,
     0,   338,   178,   179,   180,   181,   182,   183,   184,   185,
   186,   187,   188,   189,     0,     0,     0,     0,     0,     0,
     0,   343,     0,   340,     1,     2,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,   178,   179,   180,   181,   182,   183,   184,   185,
   186,   187,   188,   189,     0,     0,     0,     0,     0,     0,
     0,     0,   198,   178,   179,   180,   181,   182,   183,   184,
   185,   186,   187,   188,   189,     0,     0,     0,     0,     0,
     0,     0,     0,   231,     1,     2,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,   178,   179,   180,   181,   182,   183,   184,   185,
   186,   187,   188,   189,     0,     0,     0,   286,   178,   179,
   180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     0,     0,     0,   305,   178,   179,   180,   181,   182,   183,
   184,   185,   186,   187,   188,   189,     0,     0,     0,   306,
   178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
   188,   189,     0,     0,     0,   317,   178,   179,   180,   181,
   182,   183,   184,   185,   186,   187,   188,   189,     0,   252,
     0,   342,   178,   179,   180,   181,   182,   183,   184,   185,
   186,   187,   188,   189
};

static const short yycheck[] = {     0,
    52,    74,    75,    83,     4,     0,    23,    56,    48,    48,
    49,    50,    51,    52,    72,    48,    71,    97,    19,    48,
    78,    48,    23,    71,    19,    26,    48,    49,    50,    51,
    52,    83,    71,    72,     3,     4,    88,    54,    71,    79,
    79,    42,    59,    74,    71,    97,    79,   120,   121,    71,
    79,    52,    79,    54,    72,    75,     3,    79,    59,    71,
    78,     5,     6,     7,     8,     9,    10,    11,    12,    13,
    14,    76,    71,    78,    74,    53,   128,    55,    56,     0,
   160,    71,    83,   135,    28,    72,    53,    88,    55,    56,
    77,   143,    66,    67,    68,    52,    97,   146,    19,    77,
    72,    78,    23,   155,    75,    72,    78,    79,   160,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,   192,
   193,    42,     3,     4,    72,    71,    83,   128,    72,   209,
    78,    88,    28,    54,   135,    72,     3,     4,    59,    71,
    97,    78,   143,    48,    49,    50,    51,    52,    72,   201,
    77,    71,    92,    77,   155,    71,   208,   209,   231,   160,
   100,    53,   102,    55,    56,    52,    71,    77,     6,     7,
     8,   128,    10,    73,    79,   227,    72,    80,   135,    77,
   232,    71,   234,    77,    77,    71,   143,    65,    66,    67,
    68,   243,    75,    75,    31,    80,    83,    48,   155,    68,
   201,    88,    56,   160,    75,     4,    72,   208,   209,     0,
    97,    19,    57,    58,    59,    60,    61,    62,    63,    64,
    65,    66,    67,    68,    59,    51,   227,   104,   207,   257,
    -1,   232,   284,   234,   286,    80,    48,    49,    50,    51,
    52,   128,   243,    -1,   201,    -1,    -1,    -1,   135,    -1,
    -1,   208,   209,   305,   306,   307,   143,     5,     6,     7,
     8,     9,    10,    11,    12,   317,    -1,    -1,   155,    -1,
   227,    -1,    -1,   160,    -1,   232,    -1,   234,    -1,    -1,
    -1,    -1,    -1,   284,    -1,   286,   243,    57,    58,    59,
    60,    61,    62,    63,    64,    65,    66,    67,    68,    -1,
    -1,    -1,    -1,    -1,   305,   306,   307,    -1,    -1,    -1,
    80,    -1,    -1,    -1,   201,    -1,   317,    -1,    -1,    -1,
    -1,   208,   209,    -1,    -1,    -1,    -1,   284,    -1,   286,
    -1,    -1,    -1,    79,    -1,    -1,    -1,    -1,    -1,    -1,
   227,    -1,    -1,    -1,    -1,   232,    -1,   234,   305,   306,
   307,    -1,    -1,    99,    -1,    -1,   243,    -1,    -1,    -1,
   317,   107,   108,   109,   110,   111,   112,   113,    -1,    -1,
    -1,    -1,    -1,   119,    -1,   121,    -1,    -1,   124,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    -1,
   136,    -1,    -1,   139,   140,   141,    -1,   284,    -1,   286,
    -1,    -1,    28,    -1,    -1,    -1,    88,   153,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,   305,   306,
   307,    -1,    -1,    -1,    -1,   171,   172,    -1,    -1,    -1,
   317,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   184,   185,
   186,   187,   188,   189,   190,   191,   128,    -1,    -1,    -1,
    -1,    -1,    -1,   135,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,   143,    -1,    -1,    -1,   211,    -1,    -1,    -1,   215,
    -1,    -1,    -1,   155,    57,    58,    59,    60,    61,    62,
    63,    64,    65,    66,    67,    68,    -1,   233,    -1,   235,
    -1,   237,   238,    -1,    -1,    -1,    -1,    80,    -1,   245,
   246,   247,   248,   249,    -1,    -1,   252,    -1,    -1,   255,
   256,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   201,
    -1,   267,    -1,    -1,    -1,    -1,   208,    -1,   274,    -1,
    -1,    -1,    -1,    -1,    -1,   281,   282,   283,    -1,   285,
    -1,    -1,    -1,    -1,    -1,   227,    -1,    -1,    -1,    -1,
   232,    -1,   234,    -1,    -1,    -1,   302,    -1,   304,    -1,
    -1,   243,   308,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
   316,    -1,    -1,    -1,   320,    -1,   322,    -1,   324,    -1,
   326,    -1,   328,    -1,   330,    -1,   332,    -1,   334,    -1,
   336,    -1,   338,    -1,   340,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,   284,    -1,   286,    57,    58,    59,    60,    61,
    62,    63,    64,    65,    66,    67,    68,    -1,    -1,    -1,
    72,    -1,    -1,   305,   306,   307,    78,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,   317,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    -1,
    -1,    -1,    19,    -1,    21,    22,    23,    24,    25,    26,
    27,    28,    29,    30,    -1,    32,    33,    34,    35,    36,
    37,    38,    39,    57,    58,    59,    60,    61,    62,    63,
    64,    65,    66,    67,    68,    -1,    53,    -1,    55,    56,
    -1,    -1,    -1,     3,     4,     5,     6,     7,     8,     9,
    10,    11,    12,    13,    14,    15,    -1,    -1,    75,    19,
    77,    21,    22,    23,    24,    25,    26,    27,    28,    29,
    30,    -1,    32,    33,    34,    35,    36,    37,    38,    39,
    57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
    67,    68,    -1,    -1,    -1,    72,    -1,    -1,    -1,    -1,
    -1,    78,     3,     4,     5,     6,     7,     8,     9,    10,
    11,    12,    13,    14,    15,    75,    76,    77,    19,    -1,
    21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
    -1,    32,    33,    34,    35,    36,    37,    38,    39,    57,
    58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
    68,    -1,    -1,    -1,    72,    -1,    -1,    -1,    -1,    -1,
    78,     3,     4,     5,     6,     7,     8,     9,    10,    11,
    12,    13,    14,    15,    75,    76,    77,    19,    -1,    21,
    22,    23,    24,    25,    26,    27,    28,    29,    30,    -1,
    32,    33,    34,    35,    36,    37,    38,    39,    57,    58,
    59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
    -1,    -1,    -1,    72,    -1,    -1,    -1,    -1,    -1,    78,
     3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
    13,    14,    15,    75,    76,    77,    19,    -1,    21,    22,
    23,    24,    25,    26,    27,    28,    29,    30,    -1,    32,
    33,    34,    35,    36,    37,    38,    39,    57,    58,    59,
    60,    61,    62,    63,    64,    65,    66,    67,    68,    -1,
    -1,    -1,    72,    -1,    -1,    -1,    -1,    -1,    78,     3,
     4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
    14,    15,    75,    76,    77,    19,    -1,    21,    22,    23,
    24,    25,    26,    27,    28,    29,    30,    -1,    32,    33,
    34,    35,    36,    37,    38,    39,    57,    58,    59,    60,
    61,    62,    63,    64,    65,    66,    67,    68,    -1,    -1,
    -1,    72,    -1,    -1,    -1,    -1,    -1,    78,     3,     4,
     5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
    15,    75,    76,    77,    19,    -1,    21,    22,    23,    24,
    25,    26,    27,    28,    29,    30,    -1,    32,    33,    34,
    35,    36,    37,    38,    39,    57,    58,    59,    60,    61,
    62,    63,    64,    65,    66,    67,    68,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    78,     3,     4,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    75,    76,    77,    19,    -1,    21,    22,    23,    24,    25,
    26,    27,    28,    29,    30,    -1,    32,    33,    34,    35,
    36,    37,    38,    39,    -1,    -1,     4,     5,     6,     7,
     8,     9,    10,    11,    12,    -1,    -1,    15,    -1,    -1,
    -1,    19,    -1,    21,    22,    23,    24,    25,    26,    27,
    -1,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    75,
    -1,    77,    40,    41,    42,    43,    57,    58,    59,    60,
    61,    62,    63,    64,    65,    66,    67,    68,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    64,    78,    -1,    -1,
    -1,    -1,    70,    71,    72,    73,    74,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    -1,    -1,    15,    -1,
    -1,    -1,    19,    -1,    21,    22,    23,    24,    25,    26,
    27,    -1,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    40,    41,    42,    43,    57,    58,    59,
    60,    61,    62,    63,    64,    65,    66,    67,    68,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    78,    -1,
    -1,    -1,    -1,    70,    71,    72,    73,    74,     4,     5,
     6,     7,     8,     9,    10,    11,    12,    -1,    -1,    15,
    -1,    -1,    -1,    19,    -1,    21,    22,    23,    24,    25,
    26,    27,    -1,    29,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    40,    41,    42,    43,    57,    58,
    59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    78,
    -1,    -1,    -1,    -1,    70,    71,    -1,    73,    74,     4,
     5,     6,     7,     8,     9,    10,    11,    12,    -1,    -1,
    15,    -1,    -1,    -1,    19,    -1,    21,    22,    23,    24,
    25,    26,    27,    -1,    29,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    43,    57,
    58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
    68,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,
    78,    -1,    -1,    -1,    -1,    70,    71,    -1,    73,    74,
    57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
    67,    68,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    78,    57,    58,    59,    60,    61,    62,    63,    64,
    65,    66,    67,    68,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    78,    57,    58,    59,    60,    61,    62,
    63,    64,    65,    66,    67,    68,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    78,    57,    58,    59,    60,
    61,    62,    63,    64,    65,    66,    67,    68,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,    57,    58,
    59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,
    57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
    67,    68,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    78,    57,    58,    59,    60,    61,    62,    63,    64,
    65,    66,    67,    68,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    78,    57,    58,    59,    60,    61,    62,
    63,    64,    65,    66,    67,    68,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    78,    57,    58,    59,    60,
    61,    62,    63,    64,    65,    66,    67,    68,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,    57,    58,
    59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,
    57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
    67,    68,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    78,    57,    58,    59,    60,    61,    62,    63,    64,
    65,    66,    67,    68,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,     0,    -1,    78,     3,     4,     5,     6,     7,     8,
     9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
    19,    20,    57,    58,    59,    60,    61,    62,    63,    64,
    65,    66,    67,    68,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    77,    57,    58,    59,    60,    61,    62,    63,
    64,    65,    66,    67,    68,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    77,     3,     4,     5,     6,     7,     8,
     9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
    19,    20,    57,    58,    59,    60,    61,    62,    63,    64,
    65,    66,    67,    68,    -1,    -1,    -1,    72,    57,    58,
    59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
    -1,    -1,    -1,    72,    57,    58,    59,    60,    61,    62,
    63,    64,    65,    66,    67,    68,    -1,    -1,    -1,    72,
    57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
    67,    68,    -1,    -1,    -1,    72,    57,    58,    59,    60,
    61,    62,    63,    64,    65,    66,    67,    68,    -1,    54,
    -1,    72,    57,    58,    59,    60,    61,    62,    63,    64,
    65,    66,    67,    68
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/lib/bison.simple"
/* This file comes from bison-1.28.  */

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

#ifndef YYSTACK_USE_ALLOCA
#ifdef alloca
#define YYSTACK_USE_ALLOCA
#else /* alloca not defined */
#ifdef __GNUC__
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi) || (defined (__sun) && defined (__i386))
#define YYSTACK_USE_ALLOCA
#include <alloca.h>
#else /* not sparc */
/* We think this test detects Watcom and Microsoft C.  */
/* This used to test MSDOS, but that is a bad idea
   since that symbol is in the user namespace.  */
#if (defined (_MSDOS) || defined (_MSDOS_)) && !defined (__TURBOC__)
#if 0 /* No need for malloc.h, which pollutes the namespace;
	 instead, just don't use alloca.  */
#include <malloc.h>
#endif
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
/* I don't know what this was needed for, but it pollutes the namespace.
   So I turned it off.   rms, 2 May 1997.  */
/* #include <malloc.h>  */
 #pragma alloca
#define YYSTACK_USE_ALLOCA
#else /* not MSDOS, or __TURBOC__, or _AIX */
#if 0
#ifdef __hpux /* haible@ilog.fr says this works for HPUX 9.05 and up,
		 and on HPUX 10.  Eventually we can turn this on.  */
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#endif /* __hpux */
#endif
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc */
#endif /* not GNU C */
#endif /* alloca not defined */
#endif /* YYSTACK_USE_ALLOCA not defined */

#ifdef YYSTACK_USE_ALLOCA
#define YYSTACK_ALLOC alloca
#else
#define YYSTACK_ALLOC malloc
#endif

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Define __yy_memcpy.  Note that the size argument
   should be passed with type unsigned int, because that is what the non-GCC
   definitions require.  With GCC, __builtin_memcpy takes an arg
   of type size_t, but it can handle unsigned int.  */

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     unsigned int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, unsigned int count)
{
  register char *t = to;
  register char *f = from;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 217 "/usr/lib/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
#ifdef YYPARSE_PARAM
int yyparse (void *);
#else
int yyparse (void);
#endif
#endif

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;
  int yyfree_stacks = 0;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  if (yyfree_stacks)
	    {
	      free (yyss);
	      free (yyvs);
#ifdef YYLSP_NEEDED
	      free (yyls);
#endif
	    }
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
#ifndef YYSTACK_USE_ALLOCA
      yyfree_stacks = 1;
#endif
      yyss = (short *) YYSTACK_ALLOC (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1,
		   size * (unsigned int) sizeof (*yyssp));
      yyvs = (YYSTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1,
		   size * (unsigned int) sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1,
		   size * (unsigned int) sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 1:
#line 148 "./parser.y"
{ParseTreePointer=yyvsp[0].m_pParseNode;;
    break;}
case 2:
#line 150 "./parser.y"
{ParseTreePointer->AddLastChild(yyvsp[0].m_pParseNode);;
    break;}
case 5:
#line 160 "./parser.y"
{
								// Store a pointer to the actual shader.
								yyval.m_pParseNode=new CqParseNodeShader(yyvsp[-6].m_Identifier->c_str(),yyvsp[-7].m_ShaderType->c_str());
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[-1].m_pParseNode);

								// Now copy any initialisers from the formals list to their respective
								// local variable definitions.
								CqParseNode* pArgs=yyvsp[-4].m_pParseNode;
								if(pArgs)
								{
									// Each child of the variable_definitions is a CqParseNodeVariable
									CqParseNodeVariable* pVar=static_cast<CqParseNodeVariable*>(pArgs->pFirstChild());

									while(pVar)
									{
										// If storage is not specified, a shader parameter defaults to uniform.
										pVar->SetDefaultStorage(Type_Uniform);
										// Force the variable to be a parameter.
										pVar->SetParam();

										// Check if a default value has been specified.
										CqParseNode* pDefValue=pVar->pFirstChild();
										if(pDefValue!=0)
										{
											// Get a pointer to the local variable.
											CqVarDef* pVarDef=CqVarDef::GetVariablePtr(pVar->VarRef());
											if(pVarDef!=0)
											{
												CqParseNode Node;
												pDefValue->UnLink();
												CqParseNodeCast* pCast=new CqParseNodeCast(pVarDef->Type());
												Node.AddLastChild(pCast);
												pCast->AddLastChild(pDefValue);
												Node.Optimise();
												pVarDef->SetpDefValue(Node.pFirstChild());
											}
										}
										pVar=static_cast<CqParseNodeVariable*>(pVar->pNext());
									}
								}

							;
    break;}
case 6:
#line 204 "./parser.y"
{
								// Store a pointer to the actual shader.
								yyval.m_pParseNode=new CqParseNodeShader(yyvsp[-5].m_Identifier->c_str(), yyvsp[-6].m_ShaderType->c_str());
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[-1].m_pParseNode);
							;
    break;}
case 7:
#line 214 "./parser.y"
{
								CqParseNodeDeclaration* pDecl=static_cast<CqParseNodeDeclaration*>(yyvsp[-5].m_pParseNode);
								
								// Make a string of the parameter types.
								CqParseNode* pArgs=yyvsp[-4].m_pParseNode;
								CqString strArgTypes("");
								if(pArgs)
								{
									// Each child of the variable_definitions is a CqParseNodeVariable
									CqParseNodeVariable* pVar=static_cast<CqParseNodeVariable*>(pArgs->pFirstChild());
									while(pVar)
									{
										// If storage is not specified, a function parameter defaults to varying.
										pVar->SetDefaultStorage(Type_Varying);
										// Get the type from the variable
										strArgTypes+=CqParseNode::TypeIdentifier(pVar->ResType());
										// TODO: Find out if local function arguments can have default values.
										// If so, they can be found as the child of pVar.
										pVar=static_cast<CqParseNodeVariable*>(pVar->pNext());
									}
								}

								// Add the function declaration to the list of local functions.
								CqFuncDef funcdef(pDecl->Type(), pDecl->strName(), pDecl->strName(), strArgTypes.c_str(), yyvsp[-1].m_pParseNode, pArgs);
								CqFuncDef::AddFunction(funcdef);
								yyval.m_pParseNode=new CqParseNode();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								delete(pDecl);
								// Function level namespace is now defunct.
								ParseNameSpaceStack.erase(ParseNameSpaceStack.end()-1);
							;
    break;}
case 8:
#line 246 "./parser.y"
{
								CqParseNodeDeclaration* pDecl=static_cast<CqParseNodeDeclaration*>(yyvsp[-4].m_pParseNode);
								
								// Add the function declaration to the list of local functions.
								CqFuncDef funcdef(pDecl->Type(), pDecl->strName(), pDecl->strName(), "", yyvsp[-1].m_pParseNode, 0);
								CqFuncDef::AddFunction(funcdef);
								yyval.m_pParseNode=new CqParseNode();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								delete(pDecl);
								// Function level namespace is now defunct.
								ParseNameSpaceStack.erase(ParseNameSpaceStack.end()-1);
							;
    break;}
case 9:
#line 261 "./parser.y"
{
								yyval.m_pParseNode=new CqParseNodeDeclaration((strNameSpace()+*yyvsp[-1].m_Identifier).c_str(),yyvsp[-2].m_TypeAndSpace.Type);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								// Store the name of the function being defined for use in variable namespacing.
								ParseNameSpaceStack.push_back(strNameSpace()+*yyvsp[-1].m_Identifier+"::");
							;
    break;}
case 10:
#line 267 "./parser.y"
{	
								yyval.m_pParseNode=new CqParseNodeDeclaration((strNameSpace()+*yyvsp[-1].m_Identifier).c_str(),Type_Void);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								// Store the name of the function being defined for use in variable namespacing.
								ParseNameSpaceStack.push_back(strNameSpace()+*yyvsp[-1].m_Identifier+"::");
							;
    break;}
case 11:
#line 273 "./parser.y"
{
								// TODO: Should warn about duplicate declarations.
								CqString strName(strNameSpace());
								if(yyvsp[-1].m_pSymbol.eType&1)	strName+=CqVarDef::GetVariablePtr(yyvsp[-1].m_pSymbol.VarRef)->strName();
								else			strName+=CqFuncDef::GetFunctionPtr(yyvsp[-1].m_pSymbol.FuncRef)->strName();

								yyval.m_pParseNode=new CqParseNodeDeclaration(strName.c_str(),yyvsp[-2].m_TypeAndSpace.Type);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								// Store the name of the function being defined for use in variable namespacing.
								ParseNameSpaceStack.push_back(strName+"::");
							;
    break;}
case 12:
#line 284 "./parser.y"
{	
								// TODO: Should warn about duplicate declarations.
								CqString strName(strNameSpace());
								if(yyvsp[-1].m_pSymbol.eType&1)	strName+=CqVarDef::GetVariablePtr(yyvsp[-1].m_pSymbol.VarRef)->strName();
								else			strName+=CqFuncDef::GetFunctionPtr(yyvsp[-1].m_pSymbol.FuncRef)->strName();

								yyval.m_pParseNode=new CqParseNodeDeclaration(strName.c_str(),Type_Void);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								// Store the name of the function being defined for use in variable namespacing.
								ParseNameSpaceStack.push_back(strName+"::");
							;
    break;}
case 13:
#line 298 "./parser.y"
{ yyval.m_ShaderType=new CqString("lightsource");;
    break;}
case 14:
#line 299 "./parser.y"
{ yyval.m_ShaderType=new CqString("surface");;
    break;}
case 15:
#line 300 "./parser.y"
{ yyval.m_ShaderType=new CqString("volume");;
    break;}
case 16:
#line 301 "./parser.y"
{ yyval.m_ShaderType=new CqString("displacement");;
    break;}
case 17:
#line 302 "./parser.y"
{ yyval.m_ShaderType=new CqString("transformation");;
    break;}
case 18:
#line 303 "./parser.y"
{ yyval.m_ShaderType=new CqString("imager");;
    break;}
case 19:
#line 308 "./parser.y"
{
								// Create a list header, and add the first entry to it.
								yyval.m_pParseNode=new CqParseNode();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqParseNodeVariable* pVarNode=static_cast<CqParseNodeVariable*>(yyvsp[0].m_pParseNode->pFirstChild());
								while(pVarNode!=0)
								{
									CqParseNodeVariable* pVarNext=static_cast<CqParseNodeVariable*>(pVarNode->pNext());
									yyval.m_pParseNode->AddLastChild(pVarNode);
									pVarNode=pVarNext;
								}
							;
    break;}
case 20:
#line 321 "./parser.y"
{
								// Add this one to the list.
								CqParseNodeVariable* pVarNode=static_cast<CqParseNodeVariable*>(yyvsp[0].m_pParseNode->pFirstChild());
								while(pVarNode!=0)
								{
									CqParseNodeVariable* pVarNext=static_cast<CqParseNodeVariable*>(pVarNode->pNext());
									yyval.m_pParseNode->AddLastChild(pVarNode);
									pVarNode=pVarNext;
								}
							;
    break;}
case 22:
#line 336 "./parser.y"
{
								yyval.m_pParseNode=new CqParseNode();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqParseNodeDeclaration* pDecl=static_cast<CqParseNodeDeclaration*>(yyvsp[0].m_pParseNode->pFirstChild());
								while(pDecl)
								{
									TqInt Type=(yyvsp[-1].m_TypeAndSpace.Type);
									
									SqVarRef var;
									TqBool fv=CqVarDef::FindVariable((strNameSpace()+pDecl->strName()).c_str(), var);
									if(fv)
									{
										CqVarDef* pVar=CqVarDef::GetVariablePtr(var);
										// Check if the declaration marked it as an arry
										if(pVar->Type()&Type_Array)
											Type=(TqInt)(Type|Type_Array);

										pVar->SetType(Type);
										// Create a variable node, in the case of local variable definition, these nodes will be removed, 
										// and only the intitialisers kept.
										// In the case of function parameters, the variables will be needed for type string construction.
										CqParseNode* pVarNode=new CqParseNodeVariable(var);
										pVarNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
										yyval.m_pParseNode->AddLastChild(pVarNode);

										// Copy any initialisers
										if(pDecl->pFirstChild())
										{
											if(Type&Type_Array)
											{
												CqParseNode* pArrayInit=new CqParseNode();

												CqParseNode* pInitList=pDecl->pFirstChild();
												CqParseNode* pInit=pInitList->pFirstChild();
												TqInt i=0;
												while(pInit!=0)
												{
													CqParseNode* pInit2=pInit->pNext();
													CqParseNodeAssignArray* pInitFunc=new CqParseNodeAssignArray(var);
													pInitFunc->NoDup();
													CqParseNodeFloatConst* pIndex=new CqParseNodeFloatConst(i);

													pInitFunc->AddLastChild(pInit);
													pInitFunc->AddLastChild(pIndex);
													pArrayInit->AddLastChild(pInitFunc);

													i++;
													pInit=pInit2;
												}
												pVarNode->AddLastChild(pArrayInit);
											}
											else
											{
												// Create an assign operator to initialise the variable.
												CqParseNode* pV=new CqParseNodeAssign(var);
												pV->SetPos(ParseLineNumber,ParseStreamName.c_str());
												pV->NoDup();
												pV->AddLastChild(pDecl->pFirstChild());

												pVarNode->AddLastChild(pV);
												pDecl->ClearChild();
											}
										}
									}

									CqParseNode* pTemp=pDecl;
									pDecl=static_cast<CqParseNodeDeclaration*>(pDecl->pNext());
									delete(pTemp);
								}
							;
    break;}
case 23:
#line 407 "./parser.y"
{
								yyval.m_pParseNode=new CqParseNode();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqParseNodeDeclaration* pDecl=static_cast<CqParseNodeDeclaration*>(yyvsp[0].m_pParseNode->pFirstChild());
								while(pDecl)
								{
									SqVarRef varLocal, varExtern;
									TqBool fvl=CqVarDef::FindVariable((strNameSpace()+pDecl->strName()).c_str(), varLocal);

									// As this is an extern, we need to repeatedly check in the previous namespaces
									// until we find the variable they are referring to.
									TqBool fve=TqFalse;
									if(!ParseNameSpaceStack.empty())
									{
										std::vector<CqString>::reverse_iterator i=ParseNameSpaceStack.rbegin()+1;
										while(!fve && i!=ParseNameSpaceStack.rend())
										{
											CqString strNS=*i;
											fve=CqVarDef::FindVariable((strNS+pDecl->strName()).c_str(), varExtern);
											i++;
										}
									}

									// If we found a candidate...
									if(fve && fvl)
									{
										CqVarDef* pvarLocal=CqVarDef::GetVariablePtr(varLocal);
										CqVarDef* pvarExtern=CqVarDef::GetVariablePtr(varExtern);
										CqParseNode* pVarNode=new CqParseNodeVariable(varLocal);
										pvarLocal->SetExtern(TqTrue, varExtern);
										pvarLocal->SetType(pvarExtern->Type());
										pVarNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
										yyval.m_pParseNode->AddLastChild(pVarNode);
									}
									else
										yyerror("extern not found");

									CqParseNode* pTemp=pDecl;
									pDecl=static_cast<CqParseNodeDeclaration*>(pDecl->pNext());
									delete(pTemp);
								}
							;
    break;}
case 24:
#line 452 "./parser.y"
{
								yyval.m_TypeAndSpace.Type=(TqInt)(yyvsp[0].m_TypeAndSpace.Type|yyvsp[-1].m_VarType);
								yyval.m_TypeAndSpace.Space=yyvsp[0].m_TypeAndSpace.Space;
							;
    break;}
case 26:
#line 460 "./parser.y"
{
								// Create a list header and add the first element.
								yyval.m_pParseNode=new CqParseNode();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							;
    break;}
case 27:
#line 467 "./parser.y"
{
								// This one to the list.
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							;
    break;}
case 28:
#line 474 "./parser.y"
{
								// Create a new variable declaration based on the specified name.
								yyval.m_pParseNode=new CqParseNodeDeclaration(yyvsp[-1].m_Identifier->c_str());
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqVarDef vardef(Type_Void, (strNameSpace()+*yyvsp[-1].m_Identifier).c_str());
								CqVarDef::AddVariable(vardef);
								// Add the initialiser as the first child of the declaration.
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							;
    break;}
case 29:
#line 483 "./parser.y"
{
								// Create a new variable declaration based on the specified name.
								yyval.m_pParseNode=new CqParseNodeDeclaration(yyvsp[0].m_Identifier->c_str());
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqVarDef vardef(Type_Void, (strNameSpace()+*yyvsp[0].m_Identifier).c_str());
								CqVarDef::AddVariable(vardef);
							;
    break;}
case 30:
#line 490 "./parser.y"
{
								// Create a new variable declaration based on the specified name.
								yyval.m_pParseNode=new CqParseNodeDeclaration(yyvsp[-3].m_Identifier->c_str());
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqVarDef vardef(Type_Array, (strNameSpace()+*yyvsp[-3].m_Identifier).c_str(), static_cast<TqInt>(yyvsp[-1].m_FloatConst));
								CqVarDef::AddVariable(vardef);
							;
    break;}
case 31:
#line 498 "./parser.y"
{
								// Create a new variable declaration based on the specified name.
								yyval.m_pParseNode=new CqParseNodeDeclaration(yyvsp[-4].m_Identifier->c_str());
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqVarDef vardef(Type_Array, (strNameSpace()+*yyvsp[-4].m_Identifier).c_str(), static_cast<TqInt>(yyvsp[-2].m_FloatConst));
								CqVarDef::AddVariable(vardef);
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							;
    break;}
case 32:
#line 506 "./parser.y"
{
								// Create a new declaration based on the name.
								// TODO: Should warn about duplicate declarations.
								CqString strName("");
								if(yyvsp[-1].m_pSymbol.eType&1)	strName=CqVarDef::GetVariablePtr(yyvsp[-1].m_pSymbol.VarRef)->strName();
								else			strName=CqFuncDef::GetFunctionPtr(yyvsp[-1].m_pSymbol.FuncRef)->strName();

								yyval.m_pParseNode=new CqParseNodeDeclaration(strName.c_str());
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqVarDef vardef(Type_Void, (strNameSpace()+strName).c_str());
								CqVarDef::AddVariable(vardef);
								// Add the initialiser as the first child of the declaration.
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							;
    break;}
case 33:
#line 520 "./parser.y"
{
								CqString strName("");
								if(yyvsp[0].m_pSymbol.eType&1)	strName=CqVarDef::GetVariablePtr(yyvsp[0].m_pSymbol.VarRef)->strName();
								else			strName=CqFuncDef::GetFunctionPtr(yyvsp[0].m_pSymbol.FuncRef)->strName();

								yyval.m_pParseNode=new CqParseNodeDeclaration(strName.c_str());
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqVarDef vardef(Type_Void, (strNameSpace()+strName).c_str());
								CqVarDef::AddVariable(vardef);
							;
    break;}
case 34:
#line 530 "./parser.y"
{
								CqString strName("");
								if(yyvsp[-3].m_pSymbol.eType&1)	strName=CqVarDef::GetVariablePtr(yyvsp[-3].m_pSymbol.VarRef)->strName();
								else			strName=CqFuncDef::GetFunctionPtr(yyvsp[-3].m_pSymbol.FuncRef)->strName();

								yyval.m_pParseNode=new CqParseNodeDeclaration(strName.c_str());
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqVarDef vardef(Type_Array, (strNameSpace()+strName).c_str(), static_cast<TqInt>(yyvsp[-1].m_FloatConst));
								CqVarDef::AddVariable(vardef);
							;
    break;}
case 35:
#line 541 "./parser.y"
{
								CqString strName("");
								if(yyvsp[-4].m_pSymbol.eType&1)	strName=CqVarDef::GetVariablePtr(yyvsp[-4].m_pSymbol.VarRef)->strName();
								else			strName=CqFuncDef::GetFunctionPtr(yyvsp[-4].m_pSymbol.FuncRef)->strName();

								yyval.m_pParseNode=new CqParseNodeDeclaration(strName.c_str());
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqVarDef vardef(Type_Array, (strNameSpace()+strName).c_str(), static_cast<TqInt>(yyvsp[-2].m_FloatConst));
								CqVarDef::AddVariable(vardef);
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							;
    break;}
case 36:
#line 555 "./parser.y"
{
								yyval.m_pParseNode=yyvsp[0].m_pParseNode;
							;
    break;}
case 37:
#line 562 "./parser.y"
{
								CqParseNode* pArrayInit=new CqParseNode();
								CqParseNode* pInit=yyvsp[-1].m_pParseNode->pFirstChild();
								while(pInit)
								{
									CqParseNode* pInit2=pInit->pNext();
									pArrayInit->AddLastChild(pInit);
									pInit=pInit2;
								}
								yyval.m_pParseNode=pArrayInit;
							;
    break;}
case 38:
#line 576 "./parser.y"
{
								// Create a list header and add the first element.
								yyval.m_pParseNode=new CqParseNode();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							;
    break;}
case 39:
#line 583 "./parser.y"
{
								// This one to the list.
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							;
    break;}
case 40:
#line 590 "./parser.y"
{	yyval.m_VarType=Type_Varying;	;
    break;}
case 41:
#line 591 "./parser.y"
{	yyval.m_VarType=Type_Uniform;	;
    break;}
case 42:
#line 595 "./parser.y"
{	
								yyval.m_TypeAndSpace.Type=Type_Float;		
								yyval.m_TypeAndSpace.Space=0;
							;
    break;}
case 43:
#line 599 "./parser.y"
{
								yyval.m_TypeAndSpace.Type=Type_String;	
								yyval.m_TypeAndSpace.Space=0;
							;
    break;}
case 44:
#line 603 "./parser.y"
{
								yyval.m_TypeAndSpace.Type=Type_Void;
								yyval.m_TypeAndSpace.Space=0;
							;
    break;}
case 50:
#line 615 "./parser.y"
{
								yyval.m_TypeAndSpace.Type=Type_Point;		
								yyval.m_TypeAndSpace.Space=yyvsp[0].m_Identifier;
							;
    break;}
case 51:
#line 619 "./parser.y"
{
								yyval.m_TypeAndSpace.Type=Type_Point;		
								yyval.m_TypeAndSpace.Space=0;
							;
    break;}
case 52:
#line 626 "./parser.y"
{
								yyval.m_TypeAndSpace.Type=Type_Color;		
								yyval.m_TypeAndSpace.Space=yyvsp[0].m_Identifier;
							;
    break;}
case 53:
#line 630 "./parser.y"
{
								yyval.m_TypeAndSpace.Type=Type_Color;		
								yyval.m_TypeAndSpace.Space=0;
							;
    break;}
case 54:
#line 637 "./parser.y"
{
								yyval.m_TypeAndSpace.Type=Type_Vector;		
								yyval.m_TypeAndSpace.Space=yyvsp[0].m_Identifier;
							;
    break;}
case 55:
#line 641 "./parser.y"
{
								yyval.m_TypeAndSpace.Type=Type_Vector;		
								yyval.m_TypeAndSpace.Space=0;
							;
    break;}
case 56:
#line 648 "./parser.y"
{
								yyval.m_TypeAndSpace.Type=Type_Normal;		
								yyval.m_TypeAndSpace.Space=yyvsp[0].m_Identifier;
							;
    break;}
case 57:
#line 652 "./parser.y"
{
								yyval.m_TypeAndSpace.Type=Type_Normal;		
								yyval.m_TypeAndSpace.Space=0;
							;
    break;}
case 58:
#line 659 "./parser.y"
{
								yyval.m_TypeAndSpace.Type=Type_Matrix;		
								yyval.m_TypeAndSpace.Space=yyvsp[0].m_Identifier;
							;
    break;}
case 59:
#line 663 "./parser.y"
{
								yyval.m_TypeAndSpace.Type=Type_Matrix;		
								yyval.m_TypeAndSpace.Space=0;
							;
    break;}
case 61:
#line 674 "./parser.y"
{
								// Create a list header and add the first element.
								yyval.m_pParseNode=new CqParseNode();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddFirstChild(yyvsp[0].m_pParseNode);
							;
    break;}
case 62:
#line 681 "./parser.y"
{
								// Add this one to the list.
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							;
    break;}
case 63:
#line 688 "./parser.y"
{yyval.m_pParseNode->NoDup();;
    break;}
case 64:
#line 689 "./parser.y"
{
								if(yyval.m_pParseNode->ResType()!=Type_Void)
								{
									yyval.m_pParseNode=new CqParseNodeDrop();
									yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
									yyval.m_pParseNode->AddLastChild(yyvsp[-1].m_pParseNode);
								}
							;
    break;}
case 65:
#line 697 "./parser.y"
{
								yyval.m_pParseNode=new CqParseNodeDrop();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[-1].m_pParseNode);
							;
    break;}
case 66:
#line 703 "./parser.y"
{
								yyval.m_pParseNode=new CqParseNode();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[-1].m_pParseNode);
							;
    break;}
case 69:
#line 711 "./parser.y"
{
								// Remove the variable nodes from these leaving just the 
								// intialisation code.
								// Each child of the variable_definitions is a CqParseNodeVariable
								CqParseNodeVariable* pVar=static_cast<CqParseNodeVariable*>(yyvsp[-1].m_pParseNode->pFirstChild());
								while(pVar)
								{
									CqParseNodeVariable* pTemp=static_cast<CqParseNodeVariable*>(pVar->pNext());

									// If storage is not specified, local variable defaults to varying.
									pVar->SetDefaultStorage(Type_Varying);
									
									// Relink the initialisers, if any, after the variable.
									if(pVar->pFirstChild())
									{
										// Make sure that any change in the storage type is communicated to the initialiser
										pVar->pFirstChild()->UpdateStorageStatus();
										CqParseNode* pVarying=pVar->pFirstChild();
										pVarying->LinkAfter(pVar);
									}
									pVar->UnLink();
									delete(pVar);
									pVar=pTemp;
								}
							;
    break;}
case 71:
#line 737 "./parser.y"
{	yyval.m_pParseNode=yyvsp[-1].m_pParseNode;	;
    break;}
case 72:
#line 738 "./parser.y"
{	yyval.m_pParseNode=new CqParseNode(); ;
    break;}
case 73:
#line 739 "./parser.y"
{	yyval.m_pParseNode=new CqParseNode(); ;
    break;}
case 74:
#line 741 "./parser.y"
{
								CqParseNode* pNew=new CqParseNodeConditional();
								pNew->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pNew->AddLastChild(yyvsp[-1].m_pParseNode);
								pNew->AddLastChild(yyvsp[0].m_pParseNode);
								yyval.m_pParseNode=pNew;
							;
    break;}
case 75:
#line 749 "./parser.y"
{
								CqParseNode* pNew=new CqParseNodeConditional();
								pNew->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pNew->AddLastChild(yyvsp[-3].m_pParseNode);
								pNew->AddLastChild(yyvsp[-2].m_pParseNode);
								pNew->AddLastChild(yyvsp[0].m_pParseNode);
								yyval.m_pParseNode=pNew;
							;
    break;}
case 76:
#line 763 "./parser.y"
{
								yyval.m_pParseNode=new CqParseNodeWhileConstruct();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[-1].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							;
    break;}
case 77:
#line 770 "./parser.y"
{
								yyval.m_pParseNode=new CqParseNode();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[-6].m_pParseNode);
								CqParseNode* pW=new CqParseNodeWhileConstruct();
								pW->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(pW);
								pW->AddLastChild(yyvsp[-4].m_pParseNode);
								pW->AddLastChild(yyvsp[0].m_pParseNode);
								pW->AddLastChild(yyvsp[-2].m_pParseNode);
								// Make sure that any assigns in the two expressions don't dup
								yyvsp[-6].m_pParseNode->NoDup();
								yyvsp[-2].m_pParseNode->NoDup();
							;
    break;}
case 78:
#line 785 "./parser.y"
{
								yyval.m_pParseNode=new CqParseNodeSolarConstruct();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							;
    break;}
case 79:
#line 791 "./parser.y"
{
								yyval.m_pParseNode=new CqParseNodeSolarConstruct(TqTrue);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqParseNode* pArg=new CqParseNode();
								pArg->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pArg->AddFirstChild(yyvsp[-4].m_pParseNode);
								pArg->AddFirstChild(yyvsp[-2].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(pArg);
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
								// Make sure that any assigns in the two expressions don't dup
								yyvsp[-4].m_pParseNode->NoDup();
								yyvsp[-2].m_pParseNode->NoDup();
							;
    break;}
case 80:
#line 805 "./parser.y"
{
								yyval.m_pParseNode=new CqParseNodeIlluminateConstruct();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[-2].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
								// Make sure that any assigns in the two expressions don't dup
								yyvsp[-2].m_pParseNode->NoDup();
							;
    break;}
case 81:
#line 814 "./parser.y"
{
								yyval.m_pParseNode=new CqParseNodeIlluminateConstruct(TqTrue);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqParseNode* pArg=new CqParseNode();
								pArg->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pArg->AddFirstChild(yyvsp[-6].m_pParseNode);
								pArg->AddFirstChild(yyvsp[-4].m_pParseNode);
								pArg->AddFirstChild(yyvsp[-2].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(pArg);
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
								// Make sure that any assigns in the two expressions don't dup
								yyvsp[-6].m_pParseNode->NoDup();
								yyvsp[-4].m_pParseNode->NoDup();
								yyvsp[-2].m_pParseNode->NoDup();
							;
    break;}
case 82:
#line 830 "./parser.y"
{
								yyval.m_pParseNode=new CqParseNodeIlluminanceConstruct();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqParseNode* pArg=new CqParseNode();
								pArg->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pArg->AddFirstChild(yyvsp[-2].m_pParseNode);
								pArg->AddFirstChild(new CqParseNodeFloatConst(0));	// [nsamples]
								yyval.m_pParseNode->AddLastChild(pArg);
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
								// Make sure that any assigns in the two expressions don't dup
								yyvsp[-2].m_pParseNode->NoDup();
							;
    break;}
case 83:
#line 843 "./parser.y"
{
								yyval.m_pParseNode=new CqParseNodeIlluminanceConstruct();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqParseNode* pArg=new CqParseNode();
								pArg->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pArg->AddFirstChild(yyvsp[-4].m_pParseNode);
								pArg->AddFirstChild(yyvsp[-2].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(pArg);
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
								// Make sure that any assigns in the two expressions don't dup
								yyvsp[-4].m_pParseNode->NoDup();
								yyvsp[-2].m_pParseNode->NoDup();
							;
    break;}
case 84:
#line 857 "./parser.y"
{
								yyval.m_pParseNode=new CqParseNodeIlluminanceConstruct(TqTrue);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqParseNode* pArg=new CqParseNode();
								pArg->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pArg->AddFirstChild(yyvsp[-6].m_pParseNode);
								pArg->AddFirstChild(yyvsp[-4].m_pParseNode);
								pArg->AddFirstChild(yyvsp[-2].m_pParseNode);
								pArg->AddFirstChild(new CqParseNodeFloatConst(0));	// [nsamples]
								yyval.m_pParseNode->AddLastChild(pArg);
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
								// Make sure that any assigns in the two expressions don't dup
								yyvsp[-6].m_pParseNode->NoDup();
								yyvsp[-4].m_pParseNode->NoDup();
								yyvsp[-2].m_pParseNode->NoDup();
							;
    break;}
case 85:
#line 874 "./parser.y"
{
								yyval.m_pParseNode=new CqParseNodeIlluminanceConstruct(TqTrue);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqParseNode* pArg=new CqParseNode();
								pArg->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pArg->AddFirstChild(yyvsp[-8].m_pParseNode);
								pArg->AddFirstChild(yyvsp[-6].m_pParseNode);
								pArg->AddFirstChild(yyvsp[-4].m_pParseNode);
								pArg->AddFirstChild(yyvsp[-2].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(pArg);
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
								// Make sure that any assigns in the two expressions don't dup
								yyvsp[-8].m_pParseNode->NoDup();
								yyvsp[-6].m_pParseNode->NoDup();
								yyvsp[-4].m_pParseNode->NoDup();
								yyvsp[-2].m_pParseNode->NoDup();
							;
    break;}
case 88:
#line 899 "./parser.y"
{	
								yyval.m_pParseNode=new CqParseNode();	
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
							;
    break;}
case 89:
#line 903 "./parser.y"
{
								yyval.m_pParseNode=new CqParseNode();	
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
							;
    break;}
case 91:
#line 913 "./parser.y"
{
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("operator.", func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pFunc->AddLastChild(yyvsp[-2].m_pParseNode);
								pFunc->AddLastChild(yyvsp[0].m_pParseNode);

								yyval.m_pParseNode=pFunc;
							;
    break;}
case 92:
#line 924 "./parser.y"
{
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("operator/", func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pFunc->AddLastChild(yyvsp[-2].m_pParseNode);
								pFunc->AddLastChild(yyvsp[0].m_pParseNode);

								yyval.m_pParseNode=pFunc;
							;
    break;}
case 93:
#line 935 "./parser.y"
{
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("operator*", func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pFunc->AddLastChild(yyvsp[-2].m_pParseNode);
								pFunc->AddLastChild(yyvsp[0].m_pParseNode);

								yyval.m_pParseNode=pFunc;
							;
    break;}
case 94:
#line 946 "./parser.y"
{
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("operator^", func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pFunc->AddLastChild(yyvsp[-2].m_pParseNode);
								pFunc->AddLastChild(yyvsp[0].m_pParseNode);

								yyval.m_pParseNode=pFunc;
							;
    break;}
case 95:
#line 957 "./parser.y"
{
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("operator+", func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pFunc->AddLastChild(yyvsp[-2].m_pParseNode);
								pFunc->AddLastChild(yyvsp[0].m_pParseNode);

								yyval.m_pParseNode=pFunc;
							;
    break;}
case 96:
#line 968 "./parser.y"
{
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("operator-", func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pFunc->AddLastChild(yyvsp[-2].m_pParseNode);
								pFunc->AddLastChild(yyvsp[0].m_pParseNode);

								yyval.m_pParseNode=pFunc;
							;
    break;}
case 97:
#line 979 "./parser.y"
{
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("operator-", func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pFunc->AddFirstChild(yyvsp[0].m_pParseNode);

								yyval.m_pParseNode=pFunc;
							;
    break;}
case 99:
#line 990 "./parser.y"
{
//								if($3->ResType() == $5->ResType())
//								{
									CqParseNode* pNew=new CqParseNodeQCond();
									pNew->SetPos(ParseLineNumber,ParseStreamName.c_str());
									pNew->AddLastChild(yyvsp[-4].m_pParseNode);
									pNew->AddLastChild(yyvsp[-2].m_pParseNode);
									pNew->AddLastChild(yyvsp[0].m_pParseNode);
									yyval.m_pParseNode=pNew;
//								}
//								else
//								{
//									yyerror("expressions don't match");
//									$$=new CqParseNode();
//								}
							;
    break;}
case 100:
#line 1010 "./parser.y"
{
								yyval.m_pParseNode=new CqParseNode();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqParseNode* pCast=new CqParseNodeCast(yyvsp[-1].m_TypeAndSpace.Type);
								pCast->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pCast->AddFirstChild(yyvsp[0].m_pParseNode);
								
								TqInt Type=(TqInt)(yyvsp[-1].m_TypeAndSpace.Type&Type_Mask);
								CqString* pSpace=yyvsp[-1].m_TypeAndSpace.Space;
								// Check if the type has a valid space associated
								if(pSpace!=0 && pSpace->compare("")!=0 && 
								  ((Type==Type_Point) ||
								   (Type==Type_Normal) ||
								   (Type==Type_Vector) ||
								   (Type==Type_Matrix) ))
								{
									// Create a transform function.
									std::vector<SqFuncRef> funcTrans;
									CqString strTrans("transform");;
									if(Type==Type_Normal)	strTrans="ntransform";
									if(Type==Type_Vector)	strTrans="vtransform";
									if(Type==Type_Matrix)	strTrans="mtransform";
									if(FindFunction(strTrans.c_str(), funcTrans))
									{
										yyval.m_pParseNode=new CqParseNodeFunctionCall(funcTrans);
										yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
									
										// And create a holder for the arguments.
										CqParseNode* pFromSpace=new CqParseNodeStringConst((*yyvsp[-1].m_TypeAndSpace.Space).c_str());
										CqParseNode* pToSpace=new CqParseNodeStringConst("current");
										yyval.m_pParseNode->AddLastChild(pFromSpace);
										yyval.m_pParseNode->AddLastChild(pToSpace);
										yyval.m_pParseNode->AddLastChild(pCast);
									}
								}
								else
									yyval.m_pParseNode->AddFirstChild(pCast);
							;
    break;}
case 101:
#line 1052 "./parser.y"
{	
								yyval.m_pParseNode=new CqParseNodeFloatConst(yyvsp[0].m_FloatConst);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
							;
    break;}
case 103:
#line 1057 "./parser.y"
{
								yyval.m_pParseNode=new CqParseNodeVariable(yyvsp[0].m_pSymbol.VarRef);	
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
							;
    break;}
case 104:
#line 1061 "./parser.y"
{
								yyval.m_pParseNode=new CqParseNodeVariableArray(yyvsp[-3].m_pSymbol.VarRef);
								yyval.m_pParseNode->AddLastChild(yyvsp[-1].m_pParseNode);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
							;
    break;}
case 105:
#line 1066 "./parser.y"
{
								yyval.m_pParseNode=new CqParseNodeStringConst(yyvsp[0].m_Identifier->c_str());
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
							;
    break;}
case 109:
#line 1073 "./parser.y"
{	
								yyval.m_pParseNode=yyvsp[-1].m_pParseNode;
							;
    break;}
case 110:
#line 1077 "./parser.y"
{
								yyval.m_pParseNode=new CqParseNodeTriple();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[-5].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-3].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-1].m_pParseNode);
							;
    break;}
case 111:
#line 1085 "./parser.y"
{
								yyval.m_pParseNode=new CqParseNodeHexTuple();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[-31].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-29].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-27].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-25].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-23].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-21].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-19].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-17].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-15].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-13].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-11].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-9].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-7].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-5].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-3].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-1].m_pParseNode);
							;
    break;}
case 112:
#line 1108 "./parser.y"
{	yyval.m_pParseNode=new CqParseNodeRelOp(Op_G);	;
    break;}
case 113:
#line 1109 "./parser.y"
{	yyval.m_pParseNode=new CqParseNodeRelOp(Op_GE);	;
    break;}
case 114:
#line 1110 "./parser.y"
{	yyval.m_pParseNode=new CqParseNodeRelOp(Op_L);	;
    break;}
case 115:
#line 1111 "./parser.y"
{	yyval.m_pParseNode=new CqParseNodeRelOp(Op_LE);	;
    break;}
case 116:
#line 1112 "./parser.y"
{	yyval.m_pParseNode=new CqParseNodeRelOp(Op_EQ);	;
    break;}
case 117:
#line 1113 "./parser.y"
{	yyval.m_pParseNode=new CqParseNodeRelOp(Op_NE);	;
    break;}
case 118:
#line 1117 "./parser.y"
{
								yyval.m_pParseNode=yyvsp[-1].m_pParseNode;
							;
    break;}
case 119:
#line 1121 "./parser.y"
{
								yyval.m_pParseNode=yyvsp[-1].m_pParseNode;
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddFirstChild(yyvsp[-2].m_pParseNode);
								yyval.m_pParseNode->AddFirstChild(yyvsp[0].m_pParseNode);
							;
    break;}
case 120:
#line 1128 "./parser.y"
{
								yyval.m_pParseNode=new CqParseNodeLogicalOp(Op_LogAnd);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddFirstChild(yyvsp[-2].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							;
    break;}
case 121:
#line 1135 "./parser.y"
{
								yyval.m_pParseNode=new CqParseNodeLogicalOp(Op_LogOr);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddFirstChild(yyvsp[-2].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							;
    break;}
case 122:
#line 1141 "./parser.y"
{
								yyval.m_pParseNode=new CqParseNodeUnaryOp(Op_LogicalNot);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							;
    break;}
case 123:
#line 1150 "./parser.y"
{
								yyval.m_pParseNode=new CqParseNodeAssign(yyvsp[-2].m_pSymbol.VarRef);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							;
    break;}
case 124:
#line 1156 "./parser.y"
{
								yyval.m_pParseNode=new CqParseNodeAssign(yyvsp[-2].m_pSymbol.VarRef);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("operator+", func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pFunc->AddLastChild(new CqParseNodeVariable(yyvsp[-2].m_pSymbol.VarRef));
								pFunc->AddLastChild(yyvsp[0].m_pParseNode);

								yyval.m_pParseNode->AddLastChild(pFunc);
							;
    break;}
case 125:
#line 1170 "./parser.y"
{
								yyval.m_pParseNode=new CqParseNodeAssign(yyvsp[-2].m_pSymbol.VarRef);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("operator-", func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pFunc->AddLastChild(new CqParseNodeVariable(yyvsp[-2].m_pSymbol.VarRef));
								pFunc->AddLastChild(yyvsp[0].m_pParseNode);

								yyval.m_pParseNode->AddLastChild(pFunc);
							;
    break;}
case 126:
#line 1184 "./parser.y"
{
								yyval.m_pParseNode=new CqParseNodeAssign(yyvsp[-2].m_pSymbol.VarRef);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("operator*", func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pFunc->AddLastChild(new CqParseNodeVariable(yyvsp[-2].m_pSymbol.VarRef));
								pFunc->AddLastChild(yyvsp[0].m_pParseNode);

								yyval.m_pParseNode->AddLastChild(pFunc);
							;
    break;}
case 127:
#line 1198 "./parser.y"
{
								yyval.m_pParseNode=new CqParseNodeAssign(yyvsp[-2].m_pSymbol.VarRef);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("operator/", func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pFunc->AddLastChild(new CqParseNodeVariable(yyvsp[-2].m_pSymbol.VarRef));
								pFunc->AddLastChild(yyvsp[0].m_pParseNode);

								yyval.m_pParseNode->AddLastChild(pFunc);
							;
    break;}
case 128:
#line 1212 "./parser.y"
{
								yyval.m_pParseNode=new CqParseNodeAssignArray(yyvsp[-5].m_pSymbol.VarRef);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-3].m_pParseNode);
							;
    break;}
case 129:
#line 1219 "./parser.y"
{
								yyval.m_pParseNode=new CqParseNodeAssignArray(yyvsp[-5].m_pSymbol.VarRef);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("operator+", func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqParseNodeVariableArray* pVar=new CqParseNodeVariableArray(yyvsp[-5].m_pSymbol.VarRef);
								pVar->AddLastChild(yyvsp[-3].m_pParseNode->Clone());
								pFunc->AddLastChild(pVar);

								pFunc->AddLastChild(yyvsp[0].m_pParseNode);

								yyval.m_pParseNode->AddLastChild(pFunc);
								yyval.m_pParseNode->AddLastChild(yyvsp[-3].m_pParseNode);
							;
    break;}
case 130:
#line 1237 "./parser.y"
{
								yyval.m_pParseNode=new CqParseNodeAssignArray(yyvsp[-5].m_pSymbol.VarRef);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("operator-", func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqParseNodeVariableArray* pVar=new CqParseNodeVariableArray(yyvsp[-5].m_pSymbol.VarRef);
								pVar->AddLastChild(yyvsp[-3].m_pParseNode->Clone());
								pFunc->AddLastChild(pVar);

								pFunc->AddLastChild(yyvsp[0].m_pParseNode);

								yyval.m_pParseNode->AddLastChild(pFunc);
								yyval.m_pParseNode->AddLastChild(yyvsp[-3].m_pParseNode);
							;
    break;}
case 131:
#line 1255 "./parser.y"
{
								yyval.m_pParseNode=new CqParseNodeAssignArray(yyvsp[-5].m_pSymbol.VarRef);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("operator*", func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqParseNodeVariableArray* pVar=new CqParseNodeVariableArray(yyvsp[-5].m_pSymbol.VarRef);
								pVar->AddLastChild(yyvsp[-3].m_pParseNode->Clone());
								pFunc->AddLastChild(pVar);

								pFunc->AddLastChild(yyvsp[0].m_pParseNode);

								yyval.m_pParseNode->AddLastChild(pFunc);
								yyval.m_pParseNode->AddLastChild(yyvsp[-3].m_pParseNode);
							;
    break;}
case 132:
#line 1273 "./parser.y"
{
								yyval.m_pParseNode=new CqParseNodeAssignArray(yyvsp[-5].m_pSymbol.VarRef);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("operator/", func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqParseNodeVariableArray* pVar=new CqParseNodeVariableArray(yyvsp[-5].m_pSymbol.VarRef);
								pVar->AddLastChild(yyvsp[-3].m_pParseNode->Clone());
								pFunc->AddLastChild(pVar);

								pFunc->AddLastChild(yyvsp[0].m_pParseNode);

								yyval.m_pParseNode->AddLastChild(pFunc);
								yyval.m_pParseNode->AddLastChild(yyvsp[-3].m_pParseNode);
							;
    break;}
case 133:
#line 1294 "./parser.y"
{
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction(CqFuncDef::GetFunctionPtr(yyvsp[-3].m_pSymbol.FuncRef)->strName(), func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								while(yyvsp[-1].m_pParseNode->pFirstChild()!=0)	pFunc->AddLastChild(yyvsp[-1].m_pParseNode->pFirstChild());

								yyval.m_pParseNode=pFunc;
							;
    break;}
case 134:
#line 1303 "./parser.y"
{
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction(CqFuncDef::GetFunctionPtr(yyvsp[-2].m_pSymbol.FuncRef)->strName(), func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());

								yyval.m_pParseNode=pFunc;
							;
    break;}
case 135:
#line 1314 "./parser.y"
{
								// Create a list header, and add the first entry.
								yyval.m_pParseNode=new CqParseNode();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							;
    break;}
case 136:
#line 1321 "./parser.y"
{
								// Add this entry to the list.
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							;
    break;}
case 137:
#line 1329 "./parser.y"
{	
								// Add the texture_filename as the first argument
								yyval.m_pParseNode->AddFirstChild(yyvsp[-3].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-2].m_pParseNode);
								// Add all texture_arguments as further arguments to the function.
								CqParseNode* pParam=yyvsp[-1].m_pParseNode->pFirstChild();
								while(pParam!=0)
								{
									CqParseNode* pTemp=pParam->pNext();
									yyval.m_pParseNode->AddLastChild(pParam);
									pParam=pTemp;
								}
							;
    break;}
case 138:
#line 1343 "./parser.y"
{	
								// Add the texture_filename as the first argument
								yyval.m_pParseNode->AddFirstChild(yyvsp[-2].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(new CqParseNodeFloatConst(0));
								// Add all texture_arguments as further arguments to the function.
								CqParseNode* pParam=yyvsp[-1].m_pParseNode->pFirstChild();
								while(pParam!=0)
								{
									CqParseNode* pTemp=pParam->pNext();
									yyval.m_pParseNode->AddLastChild(pParam);
									pParam=pTemp;
								}
							;
    break;}
case 139:
#line 1357 "./parser.y"
{	
								// Add the texture_filename as the first argument
								yyval.m_pParseNode->AddFirstChild(yyvsp[-2].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-1].m_pParseNode);
							;
    break;}
case 140:
#line 1363 "./parser.y"
{	
								// Add the texture_filename as the first argument
								yyval.m_pParseNode->AddFirstChild(yyvsp[-1].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(new CqParseNodeFloatConst(0));
							;
    break;}
case 141:
#line 1371 "./parser.y"
{
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("texture", func);
								yyval.m_pParseNode=new CqParseNodeFunctionCall(func);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
							;
    break;}
case 142:
#line 1377 "./parser.y"
{
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("environment", func);
								yyval.m_pParseNode=new CqParseNodeFunctionCall(func);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
							;
    break;}
case 143:
#line 1383 "./parser.y"
{
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("bump", func);
								yyval.m_pParseNode=new CqParseNodeFunctionCall(func);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
							;
    break;}
case 144:
#line 1389 "./parser.y"
{
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("shadow", func);
								yyval.m_pParseNode=new CqParseNodeFunctionCall(func);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
							;
    break;}
case 145:
#line 1398 "./parser.y"
{	
								yyval.m_pParseNode=new CqParseNodeVariable(yyvsp[0].m_pSymbol.VarRef);	
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
							;
    break;}
case 146:
#line 1402 "./parser.y"
{	
								yyval.m_pParseNode=new CqParseNodeStringConst(yyvsp[0].m_Identifier->c_str());	
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
							;
    break;}
case 147:
#line 1409 "./parser.y"
{	yyval.m_pParseNode=yyvsp[-1].m_pParseNode; ;
    break;}
case 148:
#line 1413 "./parser.y"
{
								// Create a list header and add the first entry.
								yyval.m_pParseNode=new CqParseNode();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddFirstChild(yyvsp[0].m_pParseNode);
							;
    break;}
case 149:
#line 1420 "./parser.y"
{
								// Add this entry to the list.
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							;
    break;}
case 151:
#line 1433 "./parser.y"
{yyval.m_CommType=CommTypeAtmosphere;;
    break;}
case 152:
#line 1434 "./parser.y"
{yyval.m_CommType=CommTypeDisplacement;;
    break;}
case 153:
#line 1435 "./parser.y"
{yyval.m_CommType=CommTypeLightsource;;
    break;}
case 154:
#line 1436 "./parser.y"
{yyval.m_CommType=CommTypeSurface;;
    break;}
case 155:
#line 1437 "./parser.y"
{yyval.m_CommType=CommTypeAttribute;;
    break;}
case 156:
#line 1438 "./parser.y"
{yyval.m_CommType=CommTypeOption;;
    break;}
case 157:
#line 1439 "./parser.y"
{yyval.m_CommType=CommTypeRendererInfo;;
    break;}
case 158:
#line 1440 "./parser.y"
{yyval.m_CommType=CommTypeIncident;;
    break;}
case 159:
#line 1441 "./parser.y"
{yyval.m_CommType=CommTypeOpposite;;
    break;}
case 160:
#line 1442 "./parser.y"
{yyval.m_CommType=CommTypeTextureInfo;;
    break;}
case 161:
#line 1448 "./parser.y"
{
								CqVarDef* pVD=0;
								TqBool fError=TqFalse;
								
								if((yyvsp[-3].m_pParseNode->ResType()&Type_Mask)!=Type_String)	fError=TqTrue;

								// Get the variable, error if not a variable.
								if(yyvsp[-1].m_pSymbol.eType&1)	pVD=CqVarDef::GetVariablePtr(yyvsp[-1].m_pSymbol.VarRef);
								
								if(pVD!=0 && !fError)
								{
									yyval.m_pParseNode=new CqParseNodeCommFunction(yyvsp[-5].m_CommType, yyvsp[-1].m_pSymbol.VarRef);
									yyval.m_pParseNode->AddLastChild(yyvsp[-3].m_pParseNode);
								}
								else
								{
									yyerror("invalid variable reference");
									yyval.m_pParseNode=new CqParseNode();
								}
							;
    break;}
case 162:
#line 1470 "./parser.y"
{
								CqVarDef* pVD=0;
								TqBool fError=TqFalse;
								
                                if((yyvsp[-5].m_pParseNode->ResType()&Type_Mask)!=Type_String)	fError=TqTrue;

							    if((yyvsp[-3].m_pParseNode->ResType()&Type_Mask)!=Type_String)	fError=TqTrue;

								// Get the variable, error if not a variable.
								if(yyvsp[-1].m_pSymbol.eType&1)	pVD=CqVarDef::GetVariablePtr(yyvsp[-1].m_pSymbol.VarRef);
								
								if(pVD!=0 && !fError)
								{
                                    
	                                CqParseNode* pArgs=yyvsp[-5].m_pParseNode;
                                    CqParseNodeStringConst* pString = (CqParseNodeStringConst *) pArgs;
                                    CqString strArg("");
                                    strArg += pString->strValue();
								        
									yyval.m_pParseNode=new CqParseNodeCommFunction(yyvsp[-7].m_CommType, strArg, yyvsp[-1].m_pSymbol.VarRef);
								    yyval.m_pParseNode->AddLastChild(yyvsp[-3].m_pParseNode);
								}
								else
								{
									yyerror("invalid variable reference");
									yyval.m_pParseNode=new CqParseNode();
								}
							;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 543 "/usr/lib/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;

 yyacceptlab:
  /* YYACCEPT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 0;

 yyabortlab:
  /* YYABORT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 1;
}
#line 1501 "./parser.y"


namespace Aqsis
{

TqBool FindVariable(const char* name, SqVarRef& Ref)
{
	// First search in the current namespace, then in the global namespace.
	CqString strLocalVar(strNameSpace()+name);
	
	if(CqVarDef::FindVariable(strLocalVar.c_str(), Ref))	return(TqTrue);
	else	return(CqVarDef::FindVariable(name, Ref));

	
}


TqBool FindFunction(const char* name, std::vector<SqFuncRef>& Ref)
{
	// First search in the current namespace, then in the global namespace.
	CqString strLocalFunc(strNameSpace()+name);
	
	if(CqFuncDef::FindFunction(strLocalFunc.c_str(), Ref))	return(TqTrue);
	else	return(CqFuncDef::FindFunction(name, Ref));
}


void TypeCheck()
{
	// Typecheck any declared variables.
	TqUint i;
	for(i=0; i<gLocalVars.size(); i++)
	{
		if(gLocalVars[i].pDefValue()!=0)
			gLocalVars[i].pDefValue()->TypeCheck(CqParseNode::pAllTypes(), Type_Last-1);
	}

	// Typecheck any local functions.
	for(i=0; i<gLocalFuncs.size(); i++)
	{
		if(gLocalFuncs[i].pDef()!=0)
		{
//			TqInt RetType=gLocalFuncs[i].Type();
			gLocalFuncs[i].pDef()->TypeCheck(CqParseNode::pAllTypes(), Type_Last-1);
		}
	}

	if(ParseTreePointer)
		ParseTreePointer->TypeCheck(CqParseNode::pAllTypes(), Type_Last-1);
}


void Optimise()
{
	// Optimise any local functions.
	TqUint i;
	for(i=0; i<gLocalFuncs.size(); i++)
	{
		if(gLocalFuncs[i].pDef()!=0)
			gLocalFuncs[i].pDef()->Optimise();
	}

	if(ParseTreePointer)
		ParseTreePointer->Optimise();
}


CqString strNameSpace()	
{
	CqString strRes("");

	if(!ParseNameSpaceStack.empty())
		strRes=ParseNameSpaceStack.back();

	return(strRes);
}

void InitStandardNamespace()
{
	ParseNameSpaceStack.push_back("");
}

}


static void yyerror(const CqString Message)
{
	ParseSucceeded = false;
	(*ParseErrorStream) << "libslparse > parser > error: " << Message.c_str() << " at " << ParseStreamName.c_str() << " line " << ParseLineNumber << std::endl;
}


